=== debian/changelog ===
crawl (2:0.10.0-2) unstable; urgency=low

  * Fix link to .txt files in /usr/share/doc/crawl-common/. Closes: #660388
  * Fix link to Stone Soup icon. Closes: #647464

 -- Guus Sliepen <guus@debian.org>  Sun, 19 Feb 2012 19:27:10 +0100

crawl (2:0.10.0-1) unstable; urgency=low

  [ Adam Borowski ]
  * New upstream release.
  * Obey flags set by dpkg-buildflags.
  * Work around breakage of quiltless workflows in dpkg 1.16.1.
  * Correct a symlink to the 32x32 icon. Closes: #647464
  * Install the SVG icon as well.
  * Don't request wizmode, it is compiled in by default.

  [ Guus Sliepen ]
  * Don't let the upstream Makefile strip binaries.

 -- Guus Sliepen <guus@debian.org>  Fri, 17 Feb 2012 21:17:51 +0100
