=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,13 @@
 	DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) noopt
   endif
 endif
-CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) $(shell dpkg-buildflags --get LDFLAGS)
+CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) \
+             $(shell dpkg-buildflags --get LDFLAGS) \
+             $(shell dpkg-buildflags --get CPPFLAGS)
+
+ifeq (,$(filter terse%,$(DEB_BUILD_OPTIONS))$(filter quiet%,$(DEB_BUILD_OPTIONS)))
+        VERBOSE=V=y
+endif
 
 tree-stamp:
 	dh_testdir
@@ -28,7 +34,7 @@
 endif
 
 # The makefile is unorthodox, requiring all options to be specified on every invocation.
-ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS)
+ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS) $(VERBOSE)
 ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
 	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
 	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
